## boost1.90 1.90.0

=== CMakeLists.txt ===
# Copyright 2019, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.16)

# The default build type must be set before project()
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

project(Boost VERSION 1.90.0 LANGUAGES CXX)

set(BOOST_SUPERPROJECT_VERSION ${PROJECT_VERSION})
set(BOOST_SUPERPROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR})

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/tools/cmake/include)

include(BoostRoot)

=== libs/atomic/CMakeLists.txt ===
# Copyright 2018 Mike Dev
# Copyright 2019 Peter Dimov
# Copyright 2020-2025 Andrey Semashev
#
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.16)
project(boost_atomic VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

include(CheckCXXSourceCompiles)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# Note: We can't use the Boost::library targets in the configure checks as they may not yet be included
# by the superproject when this CMakeLists.txt is included. We also don't want to hardcode include paths
# of the needed libraries and their dependencies, recursively, as this is too fragile and requires maintenance.
# Instead, we collect include paths of all libraries and use them in the configure checks. This works faster
# if there is a unified Boost include tree in the filesystem (i.e. if `b2 headers` was run or we're in the
# official monolithic Boost distribution tree).
include(cmake/BoostLibraryIncludes.cmake)

set(boost_atomic_sources src/lock_pool.cpp)

set(CMAKE_REQUIRED_INCLUDES ${BOOST_LIBRARY_INCLUDES})
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/../config/checks/architecture/x86.cpp>\nint main() {}" BOOST_ATOMIC_TARGET_X86)
unset(CMAKE_REQUIRED_INCLUDES)

if (BOOST_ATOMIC_TARGET_X86)
    if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
        if (CMAKE_SIZEOF_VOID_P EQUAL 4)
            set(boost_atomic_sse2_cflags "/arch:SSE2")
            set(boost_atomic_sse41_cflags "/arch:SSE2")
        endif()
    elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
        if (WIN32)
            set(boost_atomic_sse2_cflags "/QxSSE2")
            set(boost_atomic_sse41_cflags "/QxSSE4.1")
        else()
            set(boost_atomic_sse2_cflags "-xSSE2")
            set(boost_atomic_sse41_cflags "-xSSE4.1")
        endif()
    else()
        set(boost_atomic_sse2_cflags "-msse -msse2")
        set(boost_atomic_sse41_cflags "-msse -msse2 -msse3 -mssse3 -msse4.1")
    endif()

    set(CMAKE_REQUIRED_INCLUDES ${BOOST_LIBRARY_INCLUDES})
    set(CMAKE_REQUIRED_FLAGS "${boost_atomic_sse2_cflags}")
    check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_sse2.cpp>" BOOST_ATOMIC_COMPILER_HAS_SSE2)
    unset(CMAKE_REQUIRED_FLAGS)
    unset(CMAKE_REQUIRED_INCLUDES)

    set(CMAKE_REQUIRED_INCLUDES ${BOOST_LIBRARY_INCLUDES})
    set(CMAKE_REQUIRED_FLAGS "${boost_atomic_sse41_cflags}")
    check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_sse41.cpp>" BOOST_ATOMIC_COMPILER_HAS_SSE41)
    unset(CMAKE_REQUIRED_FLAGS)
    unset(CMAKE_REQUIRED_INCLUDES)

    if (BOOST_ATOMIC_COMPILER_HAS_SSE2)
        set(boost_atomic_sources_sse2 src/find_address_sse2.cpp)
        set_source_files_properties(${boost_atomic_sources_sse2} PROPERTIES COMPILE_FLAGS "${boost_atomic_sse2_cflags}")
        set(boost_atomic_sources ${boost_atomic_sources} ${boost_atomic_sources_sse2})
    endif()

    if (BOOST_ATOMIC_COMPILER_HAS_SSE41)
        set(boost_atomic_sources_sse41 src/find_address_sse41.cpp)
        set_source_files_properties(${boost_atomic_sources_sse41} PROPERTIES COMPILE_FLAGS "${boost_atomic_sse41_cflags}")
        set(boost_atomic_sources ${boost_atomic_sources} ${boost_atomic_sources_sse41})
    endif()
endif()

set(CMAKE_REQUIRED_INCLUDES ${BOOST_LIBRARY_INCLUDES})
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/pthread_cond_clockwait.cpp>" BOOST_ATOMIC_HAS_PTHREAD_COND_CLOCKWAIT)
unset(CMAKE_REQUIRED_INCLUDES)

add_library(boost_atomic ${boost_atomic_sources})
add_library(Boost::atomic ALIAS boost_atomic)

target_compile_features(boost_atomic PUBLIC cxx_std_11)

target_include_directories(boost_atomic PUBLIC include)
target_include_directories(boost_atomic PRIVATE src)

target_link_libraries(boost_atomic
    PUBLIC
        Boost::assert
        Boost::config
        Boost::predef
        Boost::type_traits
    PRIVATE
        Boost::align
        Boost::preprocessor

        Threads::Threads
)

if (WIN32)
    target_link_libraries(boost_atomic
        PUBLIC
            Boost::winapi

            synchronization
    )

    if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        # MinGW-w64 defines _WIN32_WINNT to _WIN32_WINNT_WS03 by default, which disables WaitOnAddress API that is required by Boost.Atomic.
        # Define the macro ourselves to the Windows version required by Boost.Atomic.
        # https://github.com/boostorg/atomic/issues/73
        target_compile_definitions(boost_atomic PUBLIC _WIN32_WINNT=0x0A00)
    endif()
endif()

target_compile_definitions(boost_atomic
    PUBLIC
        BOOST_ATOMIC_NO_LIB
    PRIVATE
        BOOST_ATOMIC_SOURCE
)

if (BUILD_SHARED_LIBS)
    target_compile_definitions(boost_atomic PUBLIC BOOST_ATOMIC_DYN_LINK)
else()
    target_compile_definitions(boost_atomic PUBLIC BOOST_ATOMIC_STATIC_LINK)
endif()

if (BOOST_ATOMIC_HAS_PTHREAD_COND_CLOCKWAIT)
    target_compile_definitions(boost_atomic PRIVATE BOOST_ATOMIC_HAS_PTHREAD_COND_CLOCKWAIT)
endif()

if (BOOST_ATOMIC_COMPILER_HAS_SSE2)
    target_compile_definitions(boost_atomic PRIVATE BOOST_ATOMIC_USE_SSE2)
endif()
if (BOOST_ATOMIC_COMPILER_HAS_SSE41)
    target_compile_definitions(boost_atomic PRIVATE BOOST_ATOMIC_USE_SSE41)
endif()

if (BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")
    add_subdirectory(test)
endif()

=== libs/bloom/CMakeLists.txt ===
# Generated by `boostdep --cmake bloom`
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.20)

project(boost_bloom VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_bloom INTERFACE)
add_library(Boost::bloom ALIAS boost_bloom)

target_include_directories(boost_bloom INTERFACE include)

target_link_libraries(boost_bloom
  INTERFACE
    Boost::assert
    Boost::config
    Boost::container_hash
    Boost::core
    Boost::throw_exception
    Boost::type_traits
)

target_compile_features(boost_bloom INTERFACE cxx_std_11)

if(NOT CMAKE_VERSION VERSION_LESS 3.19 AND CMAKE_GENERATOR MATCHES "Visual Studio")

  file(GLOB_RECURSE boost_bloom_IDEFILES CONFIGURE_DEPENDS "include/*.hpp")
  source_group(TREE ${PROJECT_SOURCE_DIR}/include FILES ${boost_bloom_IDEFILES} PREFIX "Header Files")
  list(APPEND boost_bloom_IDEFILES extra/boost_bloom.natvis)
  target_sources(boost_bloom PRIVATE ${boost_bloom_IDEFILES})

endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/container/CMakeLists.txt ===
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_container VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES C CXX)

option(BOOST_CONTAINER_HEADER_ONLY "Disable Extended Allocators and some Polymorphic Memory Resources classes" OFF)

if(BOOST_CONTAINER_HEADER_ONLY)
  add_library(boost_container INTERFACE)
  set(_populate INTERFACE)
else()
  add_library(boost_container
    src/alloc_lib.c
    src/dlmalloc.cpp
    src/global_resource.cpp
    src/monotonic_buffer_resource.cpp
    src/pool_resource.cpp
    src/synchronized_pool_resource.cpp
    src/unsynchronized_pool_resource.cpp
  )
  set(_populate PUBLIC)
endif()


add_library(Boost::container ALIAS boost_container)

target_include_directories(boost_container ${_populate} include)

target_link_libraries(boost_container
  ${_populate}
    Boost::assert
    Boost::config
    Boost::intrusive
    Boost::move
)

target_compile_definitions(boost_container
  ${_populate} BOOST_CONTAINER_NO_LIB
  # Source files already define BOOST_CONTAINER_SOURCE
  # PRIVATE BOOST_CONTAINER_SOURCE
)

if(NOT BOOST_CONTAINER_HEADER_ONLY)
  if(BUILD_SHARED_LIBS)
    target_compile_definitions(boost_container ${_populate} BOOST_CONTAINER_DYN_LINK)
  else()
    target_compile_definitions(boost_container ${_populate} BOOST_CONTAINER_STATIC_LINK)
  endif()
endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/context/CMakeLists.txt ===
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_context VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH ${boost_context_SOURCE_DIR}/cmake)

# Build features

## Binary format

if(WIN32 OR CYGWIN)
  set(_default_binfmt pe)
elseif(APPLE)
  set(_default_binfmt mach-o)
else()
  set(_default_binfmt elf)
endif()

set(BOOST_CONTEXT_BINARY_FORMAT "${_default_binfmt}" CACHE STRING "Boost.Context binary format (elf, mach-o, pe, xcoff)")
set_property(CACHE BOOST_CONTEXT_BINARY_FORMAT PROPERTY STRINGS elf mach-o pe xcoff)

unset(_default_binfmt)

## ABI

math(EXPR _bits "${CMAKE_SIZEOF_VOID_P}*8")

if(CMAKE_SYSTEM_PROCESSOR MATCHES "^[Aa][Rr][Mm]" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  set(_default_abi aapcs)
elseif(WIN32 OR CYGWIN)
  set(_default_abi ms)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^mips")
  if(_bits EQUAL 32)
    set(_default_abi o32)
  else()
    set(_default_abi n64)
  endif()
else()
  set(_default_abi sysv)
endif()

set(BOOST_CONTEXT_ABI "${_default_abi}" CACHE STRING "Boost.Context ABI (aapcs, eabi, ms, n32, n64, o32, o64, sysv, x32)")
set_property(CACHE BOOST_CONTEXT_ABI PROPERTY STRINGS aapcs eabi ms n32 n64 o32 o64 sysv x32)

unset(_default_abi)

## Arch-and-model

set(_all_archs arm arm64 loongarch64 mips32 mips64 ppc32 ppc64 riscv64 s390x i386 x86_64 combined)

# Try at start to auto determine arch from CMake.
if(CMAKE_SYSTEM_PROCESSOR IN_LIST _all_archs)
  set(_default_arch ${CMAKE_SYSTEM_PROCESSOR})
elseif(_bits EQUAL 32)
  if(CMAKE_SYSTEM_PROCESSOR MATCHES "^[Aa][Rr][Mm]")
    set(_default_arch arm)
  elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^mips")
    set(_default_arch mips32)
  elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc32)")
    set(_default_arch ppc32)
  else()
    set(_default_arch i386)
  endif()
else()
  if(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64" OR
    CMAKE_SYSTEM_PROCESSOR MATCHES "^[Aa][Rr][Mm]") # armv8
    set(_default_arch arm64)
  elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^mips")
    set(_default_arch mips64)
  elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc64)")
    set(_default_arch ppc64)
  else()
    set(_default_arch x86_64)
  endif()
endif()

set(BOOST_CONTEXT_ARCHITECTURE "${_default_arch}" CACHE STRING "Boost.Context architecture (arm, arm64, loongarch64, mips32, mips64, ppc32, ppc64, riscv64, s390x, i386, x86_64, combined)")
set_property(CACHE BOOST_CONTEXT_ARCHITECTURE PROPERTY STRINGS ${_all_archs})

unset(_all_archs)
unset(_bits)
unset(_default_arch)

## Assembler type

if(MSVC)
  if(BOOST_CONTEXT_ARCHITECTURE STREQUAL arm64 OR BOOST_CONTEXT_ARCHITECTURE STREQUAL arm)
    set(_default_asm armasm)
  else()
    set(_default_asm masm)
  endif()
elseif(BOOST_CONTEXT_ARCHITECTURE STREQUAL arm64 AND MINGW)
  set(_default_asm armclang)
else()
  set(_default_asm gas)
endif()

set(BOOST_CONTEXT_ASSEMBLER "${_default_asm}" CACHE STRING "Boost.Context assembler (masm, gas, armasm, armclang)")
set_property(CACHE BOOST_CONTEXT_ASSEMBLER PROPERTY STRINGS masm gas armasm armclang)

unset(_default_asm)

## Assembler source suffix

if(BOOST_CONTEXT_ASSEMBLER STREQUAL armclang)
  set(_default_ext .S)
elseif(BOOST_CONTEXT_BINARY_FORMAT STREQUAL pe)
  set(_default_ext .asm)
elseif(BOOST_CONTEXT_ASSEMBLER STREQUAL gas)
  set(_default_ext .S)
else()
  set(_default_ext .asm)
endif()

set(BOOST_CONTEXT_ASM_SUFFIX "${_default_ext}" CACHE STRING "Boost.Context assembler source suffix (.asm, .S)")
set_property(CACHE BOOST_CONTEXT_ASM_SUFFIX PROPERTY STRINGS .asm .S)

unset(_default_ext)

## Implementation

set(_default_impl fcontext)

set(BOOST_CONTEXT_IMPLEMENTATION "${_default_impl}" CACHE STRING "Boost.Context implementation (fcontext, ucontext, winfib)")
set_property(CACHE BOOST_CONTEXT_IMPLEMENTATION PROPERTY STRINGS fcontext ucontext winfib)

unset(_default_impl)

#

message(STATUS "Boost.Context: "
  "architecture ${BOOST_CONTEXT_ARCHITECTURE}, "
  "binary format ${BOOST_CONTEXT_BINARY_FORMAT}, "
  "ABI ${BOOST_CONTEXT_ABI}, "
  "assembler ${BOOST_CONTEXT_ASSEMBLER}, "
  "suffix ${BOOST_CONTEXT_ASM_SUFFIX}, "
  "implementation ${BOOST_CONTEXT_IMPLEMENTATION}")

# Enable the right assembler
set(ASM_LANGUAGE)
if(BOOST_CONTEXT_IMPLEMENTATION STREQUAL "fcontext")
  if(BOOST_CONTEXT_ASSEMBLER STREQUAL gas OR BOOST_CONTEXT_ASSEMBLER STREQUAL armclang)
    if(CMAKE_CXX_PLATFORM_ID MATCHES "Cygwin")
      set(ASM_LANGUAGE ASM-ATT)
    else()
      set(ASM_LANGUAGE ASM)
    endif()
  elseif(BOOST_CONTEXT_ASSEMBLER STREQUAL armasm)
    if(MSVC)
      set(ASM_LANGUAGE ASM_MARMASM)
    else()
      set(ASM_LANGUAGE ASM_ARMASM)
    endif()
  else()
    set(ASM_LANGUAGE ASM_MASM)
  endif()
endif()

# Choose .asm sources

if(BOOST_CONTEXT_BINARY_FORMAT STREQUAL mach-o)
  set(BOOST_CONTEXT_BINARY_FORMAT macho)
endif()

set(_asm_suffix ${BOOST_CONTEXT_ARCHITECTURE}_${BOOST_CONTEXT_ABI}_${BOOST_CONTEXT_BINARY_FORMAT}_${BOOST_CONTEXT_ASSEMBLER}${BOOST_CONTEXT_ASM_SUFFIX})

set(ASM_SOURCES
  src/asm/make_${_asm_suffix}
  src/asm/jump_${_asm_suffix}
  src/asm/ontop_${_asm_suffix}
)

unset(_asm_suffix)

#

if(BOOST_CONTEXT_IMPLEMENTATION STREQUAL "fcontext")

  set(IMPL_SOURCES ${ASM_SOURCES} src/fcontext.cpp)

  if(BOOST_CONTEXT_ASSEMBLER STREQUAL masm)

    set_property(SOURCE ${ASM_SOURCES} APPEND PROPERTY COMPILE_OPTIONS "/nologo")

    if(MSVC AND NOT(MSVC_VERSION LESS 1936) AND NOT(CMAKE_CXX_SIMULATE_VERSION))
      set_property(SOURCE ${ASM_SOURCES} APPEND PROPERTY COMPILE_OPTIONS "/quiet")
    endif()

    if(BOOST_CONTEXT_ARCHITECTURE STREQUAL i386)
      set_property(SOURCE ${ASM_SOURCES} APPEND PROPERTY COMPILE_OPTIONS "/safeseh")
    endif()

  # armasm doesn't support most of these options
  elseif(NOT BOOST_CONTEXT_ASSEMBLER STREQUAL armasm) # masm
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
      set_property(SOURCE ${ASM_SOURCES} APPEND PROPERTY COMPILE_OPTIONS "-x" "assembler-with-cpp")
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      set_property(SOURCE ${ASM_SOURCES} APPEND PROPERTY COMPILE_OPTIONS "-Wno-unused-command-line-argument")
    endif()
  endif() # masm

  enable_language(${ASM_LANGUAGE})
  set_source_files_properties(${ASM_SOURCES} PROPERTIES LANGUAGE ${ASM_LANGUAGE})
else()
  set(IMPL_SOURCES
    src/continuation.cpp
    src/fiber.cpp
  )
endif()

if(WIN32 AND NOT CMAKE_CXX_PLATFORM_ID MATCHES "Cygwin")
  set(STACK_TRAITS_SOURCES
    src/windows/stack_traits.cpp
  )
else()
  set(STACK_TRAITS_SOURCES
    src/posix/stack_traits.cpp
  )
endif()

add_library(boost_context
  ${IMPL_SOURCES}
  ${STACK_TRAITS_SOURCES}
)

add_library(Boost::context ALIAS boost_context)

target_include_directories(boost_context PUBLIC include)

target_link_libraries(boost_context
  PUBLIC
    Boost::assert
    Boost::config
    Boost::core
    Boost::mp11
    Boost::pool
    Boost::predef
    Boost::smart_ptr
)

# ATTENTION. Some assemblers are picky to get --defsym,KEY=VALUE pairs where '=' is non-optional!
# Be sure all defines have the '=' character. Overkill solution: always put '=' throughout this module.

target_compile_definitions(boost_context
  PUBLIC BOOST_CONTEXT_NO_LIB=
  PRIVATE BOOST_CONTEXT_SOURCE=
)

if(BUILD_SHARED_LIBS)
  target_compile_definitions(boost_context PUBLIC BOOST_CONTEXT_DYN_LINK= BOOST_CONTEXT_EXPORT=EXPORT)
else()
  target_compile_definitions(boost_context PUBLIC BOOST_CONTEXT_STATIC_LINK= BOOST_CONTEXT_EXPORT=)
endif()

if(BOOST_CONTEXT_IMPLEMENTATION STREQUAL "ucontext")
  target_compile_definitions(boost_context PUBLIC BOOST_USE_UCONTEXT=)
endif()

if(BOOST_CONTEXT_IMPLEMENTATION STREQUAL "winfib")
  target_compile_definitions(boost_context PUBLIC BOOST_USE_WINFIB=)
endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/dynamic_bitset/CMakeLists.txt ===
# Generated by `boostdep --cmake dynamic_bitset`
# Copyright 2020 Peter Dimov
# Copyright 2025 Gennaro Prota
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_dynamic_bitset VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)
set(BOOST_DYNAMIC_BITSET_IS_ROOT OFF)
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(BOOST_DYNAMIC_BITSET_IS_ROOT ON)
endif ()

add_library(boost_dynamic_bitset INTERFACE)
add_library(Boost::dynamic_bitset ALIAS boost_dynamic_bitset)

target_include_directories(boost_dynamic_bitset INTERFACE include)

if (BOOST_DYNAMIC_BITSET_IS_ROOT)
    # This means this script will be executed as the root CMakeLists.txt
    # so the Boost:: targets are not available unless we explicitly include
    # them here. MrDocs executes this script as root too.
    if (NOT DEFINED BOOST_SRC_DIR AND DEFINED ENV{BOOST_SRC_DIR})
        set(DEFAULT_BOOST_SRC_DIR "$ENV{BOOST_SRC_DIR}")
    else ()
        set(DEFAULT_BOOST_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../..")
    endif ()
    set(BOOST_SRC_DIR ${DEFAULT_BOOST_SRC_DIR} CACHE STRING "Boost source dir to use when running CMake from this directory")
    if (NOT IS_ABSOLUTE ${BOOST_SRC_DIR})
        set(BOOST_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${BOOST_SRC_DIR}")
    endif ()

    # Validate BOOST_SRC_DIR
    set(BOOST_SRC_DIR_IS_VALID ON)
    foreach (F "CMakeLists.txt" "Jamroot" "boost-build.jam" "bootstrap.sh" "libs")
        if (NOT EXISTS "${BOOST_SRC_DIR}/${F}")
            message(STATUS "${BOOST_SRC_DIR}/${F} does not exist. Fallback to find_package.")
            set(BOOST_SRC_DIR_IS_VALID OFF)
            break()
        endif ()
    endforeach ()
    if (NOT BOOST_SRC_DIR_IS_VALID)
        message(FATAL_ERROR "BOOST_SRC_DIR is not valid. Please set it to the root of a Boost checkout.")
    endif ()

    # If BOOST_SRC_DIR is valid, fallback to find_package
    set(CMAKE_FOLDER Dependencies)
    set(BOOST_INCLUDE_LIBRARIES assert config container_hash core throw_exception)
    set(BOOST_EXCLUDE_LIBRARIES dynamic_bitset)
    set(PREV_BUILD_TESTING ${BUILD_TESTING})
    set(BUILD_TESTING OFF CACHE BOOL "Build the tests." FORCE)
    add_subdirectory(${BOOST_SRC_DIR} Dependencies/boost EXCLUDE_FROM_ALL)
    set(BUILD_TESTING ${PREV_BUILD_TESTING} CACHE BOOL "Build the tests." FORCE)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${BOOST_SRC_DIR}/tools/cmake/include")
    unset(CMAKE_FOLDER)
endif()

target_link_libraries(boost_dynamic_bitset
  INTERFACE
    Boost::assert
    Boost::config
    Boost::container_hash
    Boost::core
    Boost::throw_exception
)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

if (DYNAMIC_BITSET_MRDOCS_BUILD)
    set(INCLUDE_DIR "${CMAKE_SOURCE_DIR}/include")

    # Create a temporary source file that includes boost/dynamic_bitset.hpp.
    set(TEMP_CPP_FILE "${CMAKE_CURRENT_BINARY_DIR}/dynamic_bitset_for_mrdocs.cpp")
    file(WRITE ${TEMP_CPP_FILE} "// This file is generated automatically by CMake\n\n")
    file(APPEND ${TEMP_CPP_FILE} "#include \"boost/dynamic_bitset.hpp\"\n")

    # Create a custom target for MrDocs.
    add_library(dynamic_bitset_mrdocs_target ${TEMP_CPP_FILE})

    # This is to get the documentation of the constructor from basic_string_view.
    set_target_properties(dynamic_bitset_mrdocs_target PROPERTIES CXX_STANDARD 17 CXX_STANDARD_REQUIRED YES)

    # Set any other target properties here.
    target_include_directories(dynamic_bitset_mrdocs_target PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")
    target_link_libraries(dynamic_bitset_mrdocs_target PRIVATE boost_dynamic_bitset)
    file(GLOB BOOST_MODULE_PATHS "$ENV{BOOST_SRC_DIR}/libs/*/include")
    target_include_directories(dynamic_bitset_mrdocs_target PRIVATE ${BOOST_MODULE_PATHS})

    # Don't create any other targets.
    return()
endif()

=== libs/filesystem/CMakeLists.txt ===
# Copyright 2019 Mike Dev
# Copyright 2020-2022 Andrey Semashev
#
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at https://www.boost.org/LICENSE_1_0.txt
#
# NOTE: CMake support for Boost.Filesystem is currently experimental at best
#       and the interface is likely to change in the future

cmake_minimum_required(VERSION 3.8...3.16)
project(BoostFilesystem VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

include(CheckCXXSourceCompiles)

set(BOOST_FILESYSTEM_NO_DEPRECATED OFF CACHE BOOL "Disable deprecated functionality of Boost.Filesystem")
set(BOOST_FILESYSTEM_DISABLE_SENDFILE OFF CACHE BOOL "Disable usage of sendfile API in Boost.Filesystem")
set(BOOST_FILESYSTEM_DISABLE_COPY_FILE_RANGE OFF CACHE BOOL "Disable usage of copy_file_range API in Boost.Filesystem")
set(BOOST_FILESYSTEM_DISABLE_STATX OFF CACHE BOOL "Disable usage of statx API in Boost.Filesystem")
set(BOOST_FILESYSTEM_DISABLE_GETRANDOM OFF CACHE BOOL "Disable usage of getrandom API in Boost.Filesystem")
set(BOOST_FILESYSTEM_DISABLE_ARC4RANDOM OFF CACHE BOOL "Disable usage of arc4random API in Boost.Filesystem")
set(BOOST_FILESYSTEM_DISABLE_BCRYPT OFF CACHE BOOL "Disable usage of BCrypt API in Boost.Filesystem")
set(BOOST_FILESYSTEM_EMSCRIPTEN_USE_WASI OFF CACHE BOOL "Use WASI under emscripten in Boost.Filesystem")

# Note: We can't use the Boost::library targets in the configure checks as they may not yet be included
# by the superproject when this CMakeLists.txt is included. We also don't want to hardcode include paths
# of the needed libraries and their dependencies, recursively, as this is too fragile and requires maintenance.
# Instead, we collect include paths of all libraries and use them in the configure checks. This works faster
# if there is a unified Boost include tree in the filesystem (i.e. if `b2 headers` was run or we're in the
# official monolithic Boost distribution tree).
include(cmake/BoostLibraryIncludes.cmake)

set(CMAKE_REQUIRED_INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/src" ${BOOST_LIBRARY_INCLUDES})

check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_attribute_init_priority.cpp>" BOOST_FILESYSTEM_HAS_INIT_PRIORITY)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_cxx20_atomic_ref.cpp>" BOOST_FILESYSTEM_HAS_CXX20_ATOMIC_REF)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_stat_st_blksize.cpp>" BOOST_FILESYSTEM_HAS_STAT_ST_BLKSIZE)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_stat_st_mtim.cpp>" BOOST_FILESYSTEM_HAS_STAT_ST_MTIM)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_stat_st_mtimensec.cpp>" BOOST_FILESYSTEM_HAS_STAT_ST_MTIMENSEC)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_stat_st_mtimespec.cpp>" BOOST_FILESYSTEM_HAS_STAT_ST_MTIMESPEC)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_stat_st_birthtimensec.cpp>" BOOST_FILESYSTEM_HAS_STAT_ST_BIRTHTIMENSEC)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_stat_st_birthtimespec.cpp>" BOOST_FILESYSTEM_HAS_STAT_ST_BIRTHTIMESPEC)
if(NOT BOOST_FILESYSTEM_DISABLE_STATX)
    check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_statx.cpp>" BOOST_FILESYSTEM_HAS_STATX)
    if(NOT BOOST_FILESYSTEM_HAS_STATX)
        check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_statx_syscall.cpp>" BOOST_FILESYSTEM_HAS_STATX_SYSCALL)
    endif()
endif()
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_fdopendir_nofollow.cpp>" BOOST_FILESYSTEM_HAS_FDOPENDIR_NOFOLLOW)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_dirent_d_type.cpp>" BOOST_FILESYSTEM_HAS_DIRENT_D_TYPE)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_posix_at_apis.cpp>" BOOST_FILESYSTEM_HAS_POSIX_AT_APIS)
check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_fallocate.cpp>" BOOST_FILESYSTEM_HAS_FALLOCATE)
if(WIN32 AND NOT BOOST_FILESYSTEM_DISABLE_BCRYPT)
    set(CMAKE_REQUIRED_LIBRARIES bcrypt)
    check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_bcrypt.cpp>" BOOST_FILESYSTEM_HAS_BCRYPT)
    unset(CMAKE_REQUIRED_LIBRARIES)
endif()

unset(CMAKE_REQUIRED_INCLUDES)

set(BOOST_FILESYSTEM_SOURCES
    src/codecvt_error_category.cpp
    src/exception.cpp
    src/operations.cpp
    src/directory.cpp
    src/path.cpp
    src/path_traits.cpp
    src/portability.cpp
    src/unique_path.cpp
    src/utf8_codecvt_facet.cpp
)
if(WIN32 OR CYGWIN)
    list(APPEND BOOST_FILESYSTEM_SOURCES src/windows_file_codecvt.cpp)
endif()

add_library(boost_filesystem ${BOOST_FILESYSTEM_SOURCES})
add_library(Boost::filesystem ALIAS boost_filesystem)

target_compile_features(boost_filesystem PUBLIC
    cxx_rvalue_references
    cxx_strong_enums
    cxx_noexcept
    cxx_nullptr
    cxx_defaulted_functions
    cxx_defaulted_move_initializers
    cxx_deleted_functions
    cxx_default_function_template_args
    cxx_final
    cxx_override
)

get_target_property(BOOST_FILESYSTEM_TARGET_TYPE boost_filesystem TYPE)
if(BOOST_FILESYSTEM_TARGET_TYPE STREQUAL "SHARED_LIBRARY")
    set(CMAKE_REQUIRED_LIBRARIES "-Wl,--no-undefined")
    check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_linkflag_no_undefined.cpp>" BOOST_FILESYSTEM_HAS_LINKFLAG_NO_UNDEFINED)
    unset(CMAKE_REQUIRED_LIBRARIES)
    if(NOT BOOST_FILESYSTEM_HAS_LINKFLAG_NO_UNDEFINED)
        set(CMAKE_REQUIRED_LIBRARIES "-Wl,-undefined,error")
        check_cxx_source_compiles("#include <${CMAKE_CURRENT_SOURCE_DIR}/config/has_linkflag_no_undefined.cpp>" BOOST_FILESYSTEM_HAS_LINKFLAG_UNDEFINED_ERROR)
        unset(CMAKE_REQUIRED_LIBRARIES)
    endif()
    if(BOOST_FILESYSTEM_HAS_LINKFLAG_NO_UNDEFINED)
        if(NOT CMAKE_VERSION VERSION_LESS 3.13)
            target_link_options(boost_filesystem PRIVATE "-Wl,--no-undefined")
        else()
            target_link_libraries(boost_filesystem PRIVATE "-Wl,--no-undefined")
        endif()
    elseif(BOOST_FILESYSTEM_HAS_LINKFLAG_UNDEFINED_ERROR)
        if(NOT CMAKE_VERSION VERSION_LESS 3.13)
            target_link_options(boost_filesystem PRIVATE "-Wl,-undefined,error")
        else()
            target_link_libraries(boost_filesystem PRIVATE "-Wl,-undefined,error")
        endif()
    endif()
endif()

target_include_directories(boost_filesystem PUBLIC include)
target_include_directories(boost_filesystem PRIVATE src)

target_compile_definitions(boost_filesystem
    PUBLIC
        # NOTE:
        # We deactivate autolinking, because cmake based builds don't need it
        # and we don't implement name mangling for the library file anyway.
        # Ususally the parent CMakeLists.txt file should already have globally defined BOOST_ALL_NO_LIB
        BOOST_FILESYSTEM_NO_LIB
        $<$<STREQUAL:$<TARGET_PROPERTY:boost_filesystem,TYPE>,SHARED_LIBRARY>:BOOST_FILESYSTEM_DYN_LINK=1>
        $<$<STREQUAL:$<TARGET_PROPERTY:boost_filesystem,TYPE>,STATIC_LIBRARY>:BOOST_FILESYSTEM_STATIC_LINK=1>

    PRIVATE
        BOOST_FILESYSTEM_SOURCE
)

if(WIN32)
    target_compile_definitions(boost_filesystem PRIVATE
        _SCL_SECURE_NO_WARNINGS
        _SCL_SECURE_NO_DEPRECATE
        _CRT_SECURE_NO_WARNINGS
        _CRT_SECURE_NO_DEPRECATE
    )
endif()

if(WIN32 OR CYGWIN)
    target_compile_definitions(boost_filesystem PRIVATE
        BOOST_USE_WINDOWS_H
        _WIN32_WINNT=0x0A00
        WIN32_LEAN_AND_MEAN
        NOMINMAX
    )
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
    (CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 12 OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 12) AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 13)
    # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105329
    # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105651
    target_compile_options(boost_filesystem PRIVATE
        -Wno-restrict
    )
endif()

if(BOOST_FILESYSTEM_NO_DEPRECATED)
    target_compile_definitions(boost_filesystem PUBLIC BOOST_FILESYSTEM_NO_DEPRECATED)
endif()

if(BOOST_FILESYSTEM_HAS_INIT_PRIORITY)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_INIT_PRIORITY)
endif()

if(BOOST_FILESYSTEM_DISABLE_SENDFILE)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_DISABLE_SENDFILE)
endif()
if(BOOST_FILESYSTEM_DISABLE_COPY_FILE_RANGE)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_DISABLE_COPY_FILE_RANGE)
endif()
if(BOOST_FILESYSTEM_DISABLE_STATX)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_DISABLE_STATX)
endif()
if(BOOST_FILESYSTEM_DISABLE_GETRANDOM)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_DISABLE_GETRANDOM)
endif()
if(BOOST_FILESYSTEM_DISABLE_ARC4RANDOM)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_DISABLE_ARC4RANDOM)
endif()
if(BOOST_FILESYSTEM_DISABLE_BCRYPT)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_DISABLE_BCRYPT)
endif()
if(BOOST_FILESYSTEM_DISABLE_EMSCRIPTEN_WASI)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_DISABLE_EMSCRIPTEN_WASI)
endif()

if(BOOST_FILESYSTEM_HAS_STAT_ST_BLKSIZE)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STAT_ST_BLKSIZE)
endif()
if(BOOST_FILESYSTEM_HAS_STAT_ST_MTIM)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STAT_ST_MTIM)
endif()
if(BOOST_FILESYSTEM_HAS_STAT_ST_MTIMENSEC)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STAT_ST_MTIMENSEC)
endif()
if(BOOST_FILESYSTEM_HAS_STAT_ST_MTIMESPEC)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STAT_ST_MTIMESPEC)
endif()
if(BOOST_FILESYSTEM_HAS_STAT_ST_BIRTHTIMENSEC)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STAT_ST_BIRTHTIMENSEC)
endif()
if(BOOST_FILESYSTEM_HAS_STAT_ST_BIRTHTIMESPEC)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STAT_ST_BIRTHTIMESPEC)
endif()
if(BOOST_FILESYSTEM_HAS_STATX)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STATX)
endif()
if(BOOST_FILESYSTEM_HAS_STATX_SYSCALL)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_STATX_SYSCALL)
endif()
if(BOOST_FILESYSTEM_HAS_FDOPENDIR_NOFOLLOW)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_FDOPENDIR_NOFOLLOW)
endif()
if(BOOST_FILESYSTEM_HAS_DIRENT_D_TYPE)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_DIRENT_D_TYPE)
endif()
if(BOOST_FILESYSTEM_HAS_POSIX_AT_APIS)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_POSIX_AT_APIS)
endif()
if(BOOST_FILESYSTEM_HAS_FALLOCATE)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_FALLOCATE)
endif()

target_link_libraries(boost_filesystem
    PUBLIC
        Boost::assert
        Boost::config
        Boost::container_hash
        Boost::detail
        Boost::io
        Boost::iterator
        Boost::smart_ptr
        Boost::system
        Boost::type_traits

    PRIVATE
        Boost::core
        Boost::predef
        Boost::scope
)

if(NOT BOOST_FILESYSTEM_HAS_CXX20_ATOMIC_REF)
    target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_NO_CXX20_ATOMIC_REF)
    target_link_libraries(boost_filesystem
        PRIVATE
            Boost::atomic
    )
endif()

if(WIN32)
    if(BOOST_FILESYSTEM_HAS_BCRYPT)
        target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_BCRYPT)
        target_link_libraries(boost_filesystem PRIVATE bcrypt)
    else()
        target_compile_definitions(boost_filesystem PRIVATE BOOST_FILESYSTEM_HAS_WINCRYPT)
        if(NOT WINCE)
            target_link_libraries(boost_filesystem PRIVATE advapi32)
        else()

=== libs/geometry/CMakeLists.txt ===
# Originally generated by `boostdep --cmake geometry`
# Adapted manually
# Copyright 2020, 2021 Peter Dimov
# Copyright (c) 2024 Barend Gehrels, Amsterdam, the Netherlands.
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.20)

project(boost_geometry VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_geometry INTERFACE)
add_library(Boost::geometry ALIAS boost_geometry)

target_include_directories(boost_geometry INTERFACE include)
target_compile_features(boost_geometry INTERFACE cxx_std_14)

target_link_libraries(boost_geometry
  INTERFACE
    Boost::algorithm
    Boost::any
    Boost::array
    Boost::assert
    Boost::concept_check
    Boost::config
    Boost::core
    Boost::function_types
    Boost::graph
    Boost::iterator
    Boost::lexical_cast
    Boost::math
    Boost::move
    Boost::mpl
    Boost::multiprecision
    Boost::numeric_conversion
    Boost::qvm
    Boost::range
    Boost::rational
    Boost::static_assert
    Boost::throw_exception
    Boost::tokenizer
    Boost::tuple
    Boost::type_traits
    Boost::utility
    Boost::variant
)

# Required for Boost.Geometry Index
target_link_libraries(boost_geometry
  INTERFACE
    Boost::container
    Boost::serialization
)

# Optional requirements (for example, for adaptations)
if(BOOST_GEOMETRY_BUILD_OPTIONAL)
  target_link_libraries(boost_geometry
    INTERFACE
      Boost::fusion
      Boost::integer
      Boost::polygon
      Boost::variant2
  )

  # Mentioned in SRS Shared_grids_boost (which is optional)
  target_link_libraries(boost_geometry
    INTERFACE
      Boost::thread
  )

  # Requirements for extensions
  target_link_libraries(boost_geometry
    INTERFACE
      Boost::endian
      Boost::predef
      )

endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  if (${PROJECT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})
    # Project is root. Find Boost source.
    set(BOOST_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../.." CACHE STRING "Boost source dir to use when running CMake from this directory")
    if (NOT IS_ABSOLUTE ${BOOST_SRC_DIR})
      set(BOOST_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${BOOST_SRC_DIR}")
    endif()

    set(BOOST_SRC_DIR_IS_VALID ON)
    foreach (PATH "CMakeLists.txt" "Jamroot" "boost-build.jam" "libs")
      if (NOT EXISTS "${BOOST_SRC_DIR}/${PATH}")
        message(STATUS "${BOOST_SRC_DIR}/${PATH} does not exist. Fallback to find_package.")
        set(BOOST_SRC_DIR_IS_VALID OFF)
        break()
      endif()
    endforeach()

    # Create Boost targets from source dir or boost package.
    # These are the direct dependencies currently used in unit tests.
    set(BOOST_INCLUDE_LIBRARIES
          config
          algorithm
          any
          crc
          graph
          lexical_cast
          math
          multiprecision
          program_options
          qvm
          rational
          serialization
          tokenizer
          variant
          test)

    if (BOOST_SRC_DIR_IS_VALID)
      set(BOOST_EXCLUDE_LIBRARIES ${PROJECT_NAME})
      add_subdirectory(${BOOST_SRC_DIR} deps_/boost EXCLUDE_FROM_ALL)
    else()
      find_package(Boost 1.81.0 REQUIRED)
      foreach (BOOST_INCLUDE_LIBRARY ${BOOST_INCLUDE_LIBRARIES})
        add_library(Boost::${BOOST_INCLUDE_LIBRARY} ALIAS Boost::headers)
      endforeach ()
    endif()

  endif()

  enable_testing()
  add_subdirectory(test EXCLUDE_FROM_ALL)
  add_subdirectory(index/test EXCLUDE_FROM_ALL)

endif()

if(BUILD_DOCUMENTATION)
  add_subdirectory(doc/src/examples)
  add_subdirectory(doc/src/docutils/tools/support_status)
endif()

=== libs/heap/CMakeLists.txt ===
# Generated by `boostdep --cmake heap`
# Copyright 2020 Peter Dimov
# Copyright 2025 Alexander Grund
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.16)

project(boost_heap VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

option(BOOST_HEAP_BUILD_TESTS "Build boost::heap tests" OFF)
option(BOOST_HEAP_USE_FILE_SET "Use FILE_SET for boost::heap" OFF)

if (NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()

add_library(boost_heap INTERFACE)
add_library(Boost::heap ALIAS boost_heap)

target_include_directories(boost_heap INTERFACE include)
target_compile_features(boost_heap INTERFACE cxx_std_14)

target_link_libraries(boost_heap
  INTERFACE
    Boost::assert
    Boost::concept_check
    Boost::config
    Boost::core
    Boost::intrusive
    Boost::iterator
    Boost::parameter
    Boost::static_assert
    Boost::throw_exception
)

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.23 AND BOOST_HEAP_USE_FILE_SET)
    set(Headers
        include/boost/heap/detail/ilog2.hpp
        include/boost/heap/detail/heap_comparison.hpp
        include/boost/heap/detail/mutable_heap.hpp
        include/boost/heap/detail/ordered_adaptor_iterator.hpp
        include/boost/heap/detail/stable_heap.hpp
        include/boost/heap/detail/tree_iterator.hpp
        include/boost/heap/detail/heap_node.hpp
        include/boost/heap/heap_concepts.hpp
        include/boost/heap/heap_merge.hpp
        include/boost/heap/policies.hpp
        include/boost/heap/binomial_heap.hpp
        include/boost/heap/d_ary_heap.hpp
        include/boost/heap/fibonacci_heap.hpp
        include/boost/heap/pairing_heap.hpp
        include/boost/heap/priority_queue.hpp
        include/boost/heap/skew_heap.hpp
    )

    target_sources(boost_heap PUBLIC FILE_SET HEADERS FILES ${Headers} )
endif()

if( BOOST_HEAP_BUILD_TESTS OR BUILD_TESTING )
    add_subdirectory(test)
endif()

=== libs/lexical_cast/CMakeLists.txt ===
# Generated by `boostdep --cmake lexical_cast`
# Copyright 2020 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_lexical_cast VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_lexical_cast INTERFACE)
add_library(Boost::lexical_cast ALIAS boost_lexical_cast)

target_include_directories(boost_lexical_cast INTERFACE include)

target_link_libraries(boost_lexical_cast
  INTERFACE
    Boost::config
    Boost::container
    Boost::core
    Boost::throw_exception
)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== libs/math/CMakeLists.txt ===
# Copyright 2020 Peter Dimov
# Copyright 2021 Matt Borland
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.16)

project(boost_math VERSION 1.90.0 LANGUAGES CXX)

add_library(boost_math INTERFACE)

add_library(Boost::math ALIAS boost_math)

target_include_directories(boost_math INTERFACE include)
if(NOT CMAKE_VERSION VERSION_LESS "3.19")
  file(GLOB_RECURSE headers include/*.hpp)
  target_sources(boost_math PRIVATE ${headers})
endif()

include(CMakeDependentOption)

cmake_dependent_option(BOOST_MATH_STANDALONE "Use Boost.Math in standalone mode" ON "NOT BOOST_SUPERPROJECT_VERSION" OFF)

message(STATUS "Boost.Math: standalone mode ${BOOST_MATH_STANDALONE}")

if(BOOST_MATH_STANDALONE)

  target_compile_definitions(boost_math INTERFACE BOOST_MATH_STANDALONE=1)

else()

  target_link_libraries(boost_math
    INTERFACE
      Boost::assert
      Boost::concept_check
      Boost::config
      Boost::core
      Boost::integer
      Boost::lexical_cast
      Boost::predef
      Boost::random
      Boost::static_assert
      Boost::throw_exception
  )

endif()

target_compile_features(boost_math INTERFACE cxx_std_14)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

# Only enable tests when we're the root project
elseif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

  include(CTest)
  add_subdirectory(test)
  
  include(GNUInstallDirs)
  install(DIRECTORY "include/" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

endif()

=== libs/mp11/CMakeLists.txt ===
# Copyright 2018, 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_mp11 VERSION 1.90.0 LANGUAGES CXX)

add_library(boost_mp11 INTERFACE)
add_library(Boost::mp11 ALIAS boost_mp11)

target_include_directories(boost_mp11 INTERFACE include)
target_compile_features(boost_mp11 INTERFACE cxx_alias_templates cxx_variadic_templates cxx_decltype)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

  # Fetch support files

  message(STATUS "Fetching BoostFetch.cmake")

  file(DOWNLOAD
    "https://raw.githubusercontent.com/boostorg/cmake/develop/include/BoostFetch.cmake"
    "${CMAKE_BINARY_DIR}/fetch_and_include/BoostFetch.cmake"
  )

  include("${CMAKE_BINARY_DIR}/fetch_and_include/BoostFetch.cmake")

  boost_fetch(boostorg/cmake TAG develop NO_ADD_SUBDIR)

  FetchContent_GetProperties(boostorg_cmake)

  list(APPEND CMAKE_MODULE_PATH ${boostorg_cmake_SOURCE_DIR}/include)

  # Testing (off by default)

  option(BUILD_TESTING "Build the tests." OFF)
  include(CTest)

  if(BUILD_TESTING)

    set(BUILD_TESTING OFF) # hide cache variable

    boost_fetch(boostorg/assert TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/config TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/core TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/static_assert TAG develop EXCLUDE_FROM_ALL)
    boost_fetch(boostorg/throw_exception TAG develop EXCLUDE_FROM_ALL)

    unset(BUILD_TESTING)

  endif()

  # Do not use the default BoostInstall versioned layout on Windows when standalone
  set(BOOST_INSTALL_LAYOUT "system" CACHE STRING "Installation layout (versioned, tagged, or system)")

  include(BoostInstall)

  boost_install(TARGETS boost_mp11 HEADER_DIRECTORY include/)

endif()

if(BUILD_TESTING)

  add_subdirectory(test)

endif()

=== debian/changelog ===
boost1.90 (1.90.0-5) unstable; urgency=medium

  * [6c5f56a] Better fix for reproducible build

 -- Anton Gladky <gladk@debian.org>  Fri, 20 Feb 2026 01:32:33 +0000

boost1.90 (1.90.0-4) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * [aef8912] Add check for duplicate definition of SIGLOST. (Closes: #1128264)

  [ Anton Gladky ]
  * [55346d3] fix(debian): make build reproducible

 -- Anton Gladky <gladk@debian.org>  Wed, 18 Feb 2026 20:40:55 -0800

boost1.90 (1.90.0-3) unstable; urgency=medium

  [ Pino Toscano ]
  * [d6b6799] Disable boost.stacktrace.from_exception also on hurd-i386.

  [ Anton Gladky ]
  * [c1d2abd] skip mpi test on i386. (Closes: #1127608)

 -- Anton Gladky <gladk@debian.org>  Fri, 13 Feb 2026 22:50:16 +0000

boost1.90 (1.90.0-2) unstable; urgency=medium

  [ Matthias Klose ]
  * [c6e6e98] Update inter-package dependencies. (Closes: #1127143, #1127305)
  * [602001a] Update d/tests, remove signals tests. (Closes: #1127145)

  [ Anton Gladky ]
  * [6852a4a] chore(debian): Drop kfreebsd architectures support.
  * [253aab1] Disable several autopkgtests, all of them need to be reviewed,

  [ Simon Chopin ]
  * [c0c6afb] Dont clear CXXFLAGS when bootstrapping b2.

 -- Anton Gladky <gladk@debian.org>  Sat, 07 Feb 2026 19:43:58 +0100

boost1.90 (1.90.0-1) unstable; urgency=medium

  * Upload into unstable
  * [25bd8ef] Fix architecture restrictions in d/tests/control.
              (Closes: #1127057)
  * [139712a] Update Boost test dependencies to 1.90. (Closes: #1127058)

 -- Anton Gladky <gladk@debian.org>  Thu, 05 Feb 2026 20:07:16 +0100

boost1.90 (1.90.0-1~exp1) experimental; urgency=medium

  * New upstream version
  * Update Source, Package names, Depends/Conflicts/Suggests fields.
  * Remove obsolete patches (hurd, alpha, charconv-ppc64le fix).
  * Add support for Python 3.13/3.14 in Boost.Build configuration.
  * Clean up debian/rules and debian/copyright.

 -- Anton Gladky <gladk@debian.org>  Thu, 01 Jan 2026 19:02:08 +0100

boost1.88 (1.88.0-1.4) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 16:20:06 +0200

boost1.88 (1.88.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Aug 2025 12:51:50 +0200

boost1.88 (1.88.0-1.2) experimental; urgency=medium

  * Non-maintainer upload.
  * Update inter-package dependencies:
    - libboost-mpi1.88-dev: Depend on libboost-graph1.88-dev.
    - libboost-wave1.88-dev: Depend on libboost-container1.88-dev.
    - libboost-wave1.88-dev: Depend on libboost-regex1.88-dev.
  * libboost-chrono1.88.0: Provide libboost-chrono1.88.0t64.

 -- Matthias Klose <doko@debian.org>  Sun, 10 Aug 2025 14:32:59 +0200

boost1.88 (1.88.0-1.1) experimental; urgency=medium

  * Non-maintainer upload.
  * Update inter-package dependencies: Closes: #1110562, #1110589.
    - libboost-coroutine1.88-dev: Depend on libboost-exception1.88-dev.
    - libboost-locale1.88-dev: Depend on libboost-charconv1.88-dev.
    - libboost-python1.88-dev: Depend on libboost-container1.88-dev.
    - libboost-python1.88-dev: Depend on libboost-graph1.88-dev.
    - libboost-iostreams1.88-dev: Depend on libboost-random1.88-dev.
    - libboost-charconv1.88-dev: Depend on libboost-charconv1.88.0.
      Closes: #1109450.
    - libboost-mpi1.88-dev: Depend on libboost-container1.88-dev.
  * New packages libboost-process1.88.0 and libboost-process1.88-dev.
    libboost1.88-all-dev: Depends on libboost-process1.88-dev. Closes: #1106723.
  * libboost-chrono1.88.0t64: Rename to libboost-chrono1.88.0. Closes: #1110509.
  * Fix ftbfs on hurd-amd64 (Petter Reinholdtsen). Closes: #1104617, #1102194.
  * Fix ftbfs on alpha (Petter Reinholdtsen). Closes: #1104561.
  * d/rules: Replace apt show with dpkg-query (Jochen Sprickerhof).
    Closes: #1103784.
  * Fix ppc64el build with IEEE long double. LP: #2110099. Closes: #1110403.
  * https://github.com/boostorg/boost/issues/1035
  * d/rules (override_dh_auto_build-common): Don't create a stamp.
  * d/rules (clean): Remove two generated files.
  * Update watch file.

 -- Matthias Klose <doko@debian.org>  Sat, 09 Aug 2025 14:35:51 +0200

boost1.88 (1.88.0-1) unstable; urgency=medium

  * New stable version.

 -- Anton Gladky <gladk@debian.org>  Tue, 22 Apr 2025 08:38:04 +0200

boost1.88 (1.88.0~beta1-1) unstable; urgency=medium

  * [df53d4e] Disable boost.stacktrace.from_exception on some archs.
              (Closes: #1102107)
  * Upload into unstable.

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Apr 2025 15:27:52 +0200

boost1.88 (1.88.0~beta1-1~exp1) experimental; urgency=medium

  * [9291fb5] Update patches for 1.88
  * [9738360] Update d/copyright
  * [1a78c7b] Update d/control, d/rules for new version

 -- Anton Gladky <gladk@debian.org>  Wed, 02 Apr 2025 20:07:45 +0200

boost1.83 (1.83.0-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Another fix for numpy 2.0. Closes: #1099671.
    - Compare pointers directly instead of using PyArray_EquivTypes
  * Enable context library on ppc64. Closes: #1071542.
  * Use static const for next/prior from C++17. Closes: #1093824.

 -- Matthias Klose <doko@debian.org>  Tue, 25 Mar 2025 14:04:56 +0100

boost1.83 (1.83.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with NumPy 2.x. Closes: #1094654.

 -- Matthias Klose <doko@debian.org>  Fri, 14 Feb 2025 16:45:31 +0100

boost1.83 (1.83.0-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * control: Add hurd-amd64 for context, coroutine, fiber packages.
  * [a2dab5e] control: Add hurd-amd64 for context, coroutine, fiber packages.

  [ Heinrich Schuchardt ]
  * [62a479e] Fix autopkgtests fail on armhf. (Closes: #1079106)

  [ Anton Gladky ]
  * [49b0d7f] Update the minimal cmake version for autopkgtest to 3.18.
              (Closes: #1087853)



=== debian/control ===
Source: boost1.90
Homepage: https://www.boost.org/
Section: libs
Priority: optional
Maintainer: Debian Boost Team <team+boost@tracker.debian.org>
Uploaders: 
 Giovanni Mascellani <gio@debian.org>,
 Anton Gladky <gladk@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 12), dpkg-dev (>= 1.16.1~), dctrl-tools, chrpath,
 zlib1g-dev, libbz2-dev, liblzma-dev, libzstd-dev, libicu-dev (>= 63.1), mpi-default-dev,
 bison, flex, docbook-to-man, help2man, xsltproc, doxygen,
 docbook-xsl, docbook-xml, texlive-latex-base, ghostscript,
 dh-python,
 g++ (>= 4:5-0),
 python3, python3-all-dev (>= 3.1), python3-numpy
Build-Depends-Indep: graphviz
Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
Vcs-Browser: https://salsa.debian.org/debian/boost
Vcs-Git: https://salsa.debian.org/debian/boost.git
Standards-Version: 4.6.2

Package: libboost1.90-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++-${gxx:major}-dev
Suggests: libboost1.90-doc,
 libboost-atomic1.90-dev,
 libboost-chrono1.90-dev,
 libboost-container1.90-dev,
 libboost-context1.90-dev [i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-contract1.90-dev,
 libboost-coroutine1.90-dev [i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-date-time1.90-dev,
 libboost-exception1.90-dev,
 libboost-fiber1.90-dev [i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-filesystem1.90-dev,
 libboost-graph-parallel1.90-dev,
 libboost-graph1.90-dev,
 libboost-iostreams1.90-dev,
 libboost-json1.90-dev,
 libboost-locale1.90-dev,
 libboost-log1.90-dev,
 libboost-math1.90-dev,
 libboost-mpi-python1.90-dev,
 libboost-mpi1.90-dev,
 libboost-nowide1.90-dev,
 libboost-numpy1.90-dev,
 libboost-program-options1.90-dev,
 libboost-python1.90-dev,
 libboost-random1.90-dev,
 libboost-regex1.90-dev,
 libboost-serialization1.90-dev,
 libboost-stacktrace1.90-dev,
 libboost-test1.90-dev,
 libboost-thread1.90-dev,
 libboost-timer1.90-dev,
 libboost-type-erasure1.90-dev,
 libboost-url1.90-dev,
 libboost-wave1.90-dev,
 libboost1.90-tools-dev,
 libmpfrc++-dev,
 libntl-dev
Conflicts: bjam, boost-build, libboost1.42-dev, libboost1.46-dev, libboost1.48-dev, libboost1.49-dev, libboost1.50-dev, libboost1.52-dev, libboost1.53-dev, libboost1.54-dev, libboost1.55-dev, libboost1.57-dev, libboost1.58-dev, libboost1.60-dev, libboost1.61-dev, libboost1.62-dev, libboost1.63-dev, libboost1.65-dev, libboost1.67-dev, libboost1.70-dev, libboost1.71-dev, libboost1.74-dev, libboost1.80-dev, libboost1.81-dev, libboost1.83-dev, libboost1.88-dev, libboost1.89-dev
Breaks: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
Replaces: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers for all Boost libraries.
 .
 Extended precision arithmetic package libmpfrc++-dev or libntl-dev is
 required to use the Boost.Multiprecision wrapping of the respective
 library.

Package: libboost1.90-tools-dev
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xsltproc,
 doxygen,
 docbook-xml (>= 4.2),
 docbook-xsl (>= 1.73.2),
 default-jdk (>= 1.4),
 fop (>= 0.94)
Conflicts: bjam, boost-build, libboost1.49-dev, libboost1.53-tools-dev, libboost1.54-tools-dev, libboost1.55-tools-dev, libboost1.57-tools-dev, libboost1.58-tools-dev, libboost1.60-tools-dev, libboost1.61-tools-dev, libboost1.62-tools-dev, libboost1.63-tools-dev, libboost1.65-tools-dev, libboost1.67-tools-dev, libboost1.70-tools-dev, libboost1.71-tools-dev, libboost1.74-tools-dev, libboost1.80-tools-dev, libboost1.81-tools-dev, libboost1.83-tools-dev, libboost1.88-tools-dev, libboost1.89-tools-dev
Replaces: bjam, boost-build, libboost1.49-dev, libboost1.53-dev, libboost1.53-tools-dev
Description: Boost C++ Libraries development tools
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the auxiliary tools bjam, Boost.Build, bcp,
 inspect, boostbook and quickbook.

Package: libboost1.90-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.90-dev,
 libboost1.90-tools-dev,
 libboost-atomic1.90-dev,
 libboost-chrono1.90-dev,
 libboost-container1.90-dev,
 libboost-context1.90-dev [i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-coroutine1.90-dev [i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-date-time1.90-dev,
 libboost-exception1.90-dev,
 libboost-fiber1.90-dev [i386 hurd-i386 amd64 hurd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-filesystem1.90-dev,
 libboost-graph-parallel1.90-dev,
 libboost-graph1.90-dev,
 libboost-iostreams1.90-dev,
 libboost-json1.90-dev,
 libboost-locale1.90-dev,
 libboost-log1.90-dev,
 libboost-math1.90-dev,
 libboost-mpi-python1.90-dev,
 libboost-mpi1.90-dev,
 libboost-nowide1.90-dev,
 libboost-numpy1.90-dev,
 libboost-process1.90-dev,
 libboost-program-options1.90-dev,
 libboost-python1.90-dev,
 libboost-random1.90-dev,
 libboost-regex1.90-dev,
 libboost-serialization1.90-dev,
 libboost-stacktrace1.90-dev,
 libboost-test1.90-dev,
 libboost-thread1.90-dev,
 libboost-timer1.90-dev,
 libboost-type-erasure1.90-dev,
 libboost-url1.90-dev,
 libboost-wave1.90-dev
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This metapackage provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.90-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-mathjax
Suggests: libboost1.90-dev (>= ${source:Version})
Conflicts: libboost1.42-doc, libboost1.46-doc, libboost1.48-doc, libboost1.49-doc, libboost1.50-doc, libboost1.52-doc, libboost1.53-doc, libboost1.54-doc, libboost1.55-doc, libboost1.57-doc, libboost1.58-doc, libboost1.60-doc, libboost1.61-doc, libboost1.62-doc, libboost1.63-doc, libboost1.65-doc, libboost1.67-doc, libboost1.70-doc, libboost1.71-doc, libboost1.74-doc, libboost1.80-doc, libboost1.81-doc, libboost1.83-doc, libboost1.88-doc, libboost1.89-doc
Description: Boost.org libraries documentation placeholder
 This package originally provided documentation, but has since fallen
 into disrepair and presently provides no documentation.  Please
 use documentation at www.boost.org.

Package: libboost-atomic1.90.0
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.

Package: libboost-atomic1.90-dev
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.90-dev (= ${binary:Version}),
 libboost-atomic1.90.0 (= ${binary:Version})
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.
Conflicts: libboost-atomic1.53-dev, libboost-atomic1.54-dev, libboost-atomic1.55-dev, libboost-atomic1.57-dev, libboost-atomic1.58-dev, libboost-atomic1.60-dev, libboost-atomic1.61-dev, libboost-atomic1.62-dev, libboost-atomic1.63-dev, libboost-atomic1.65-dev, libboost-atomic1.67-dev, libboost-atomic1.70-dev, libboost-atomic1.71-dev, libboost-atomic1.74-dev, libboost-atomic1.80-dev, libboost-atomic1.81-dev, libboost-atomic1.83-dev, libboost-atomic1.88-dev, libboost-atomic1.89-dev

Package: libboost-chrono1.90.0
Breaks: libboost-chrono1.88.0t64
Replaces: libboost-chrono1.88.0t64
Provides: libboost-chrono1.88.0t64 (= ${binary:Version})
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ representation of time duration, time point, and clocks
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost.Chrono library provides:
 .
  * A means to represent time durations: managed by the generic duration
    class.Examples of time durations include days, minutes, seconds and
    nanoseconds, which can be represented with a fixed number of clock
    ticks per unit. All of these units of time duration are united with
    a generic interface by the duration facility.
  * A type for representing points in time: time_point. A time_point
    represents an epoch plus or minus a duration. The library leaves
    epochs unspecified. A time_point is associated with a clock.
  * Several clocks, some of which may not be available on a particular
    platform: system_clock, steady_clock and high_resolution_clock. A
    clock is a pairing of a time_point and duration, and a function
    which returns a time_point representing now.
 .
 To make the timing facilities more generally useful, Boost.Chrono

=== debian/rules ===
#! /usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Boost libraries for which we want separate packages
# context is conditionally compiled because it is not supported yet on several architectures
# coroutine, and fiber depend on context, so they are also conditionally compiled
boost_libs := atomic chrono container contract date-time exception filesystem	\
              graph graph-parallel iostreams locale log math mpi	\
              mpi-python nowide program-options python random regex	\
              serialization stacktrace test thread timer \
              type-erasure wave json url charconv process

# these are special cases, where /usr/lib name differs from Boost library name
boost_lib_log := log log_setup
boost_lib_math := math_c99 math_c99f math_tr1 math_tr1f
boost_lib_math_long_double := math_c99l math_tr1l
boost_lib_serialization := serialization wserialization
ifeq ($(DEB_BUILD_ARCH), m68k)
# See https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=962072
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_basic
else
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_backtrace stacktrace_basic
endif
boost_lib_test := prg_exec_monitor test_exec_monitor unit_test_framework

pyversions = $(shell py3versions -rv)
pyverids = $(subst .,,$(pyversions))

# These are special cases for suffixes.
boost_suffixes_python := $(pyverids)
boost_suffixes_numpy := $(pyverids)
boost_suffixes_mpi-python := $(pyverids)

# Files that are generated by filtering a template
filtered_files =

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

version_full := $(shell dpkg-parsechangelog | grep Version | cut -d' ' -f2)
version_upstream := $(shell echo $(version_full) | cut -d'-' -f1 | cut -d '+' -f1 | cut -d'~' -f1)
version_major := $(shell echo $(version_upstream) | cut -d'.' -f1,2)

PKGVERSION = $(version_major)
SOVERSION = $(version_upstream)

icuabi = $(shell dpkg-query -W -f '$${Depends}' libicu-dev | sed -n 's/libicu\([0-9]*\) .*/\1/p')
regexicuabi = libboost-regex$(SOVERSION)-icu$(icuabi)

# Function to map Boost component name to set of shared library names
# Input: Boost component name
# Return: shared library names for the given Boost library
boost_lib = $(if $(boost_lib_$(1)), $(boost_lib_$(1)), $(1))

# Function to map Boost component name to set of suffixes for the library
# Input: Boost component name
# Return: suffixes for the given Boost component
boost_suffixes = $(if $(boost_suffixes_$(1)), $(boost_suffixes_$(1)),"")

# Helpers to make basic and decorated library names
# Input: library, suffix
# Return: base library filename for short or full name
mk_base_name = usr/lib/$(DEB_HOST_MULTIARCH)/libboost_$(subst -,_,$(1))$(2)
mk_cmake_name = usr/lib/$(DEB_HOST_MULTIARCH)/cmake/boost_$(subst -,_,$(1))-$(SOVERSION)/

# Input: component
# Return: package name for shared library or development
mk_pkg_lib = libboost-$(1)$(SOVERSION)
mk_pkg_dev = libboost-$(1)$(PKGVERSION)-dev
# Helpers to generate debhelper input filenames.
# Input: component
# Return: prefix to debhelper filenames
mk_deb_lib = debian/$(call mk_pkg_lib,$(1))
mk_deb_dev = debian/$(call mk_pkg_dev,$(1))

# Helpers that update debhelper .install or .links files
# Input: component, library, suffix
# Output: none
mk_so_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).so.$(SOVERSION) >> $(call mk_deb_lib,$(1)).install)
mk_a_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).a >> $(call mk_deb_dev,$(1)).install)
mk_ln_files = $(shell echo $(call mk_base_name,$(2),$(3)).so.$(SOVERSION) $(call mk_base_name,$(2),$(3)).so >> $(call mk_deb_dev,$(1)).links)
mk_cmake_files = $(shell echo debian/tmp/$(call mk_cmake_name,$(2),$(3)) >> $(call mk_deb_dev,$(1)).install)

# Specify the type of files/links to install.
# Special cases first, then general rule
boost_filetypes_exception = a cmake
boost_filetypes_test_exec_monitor = a cmake
boost_filetypes = $(if $(boost_filetypes_$(1)), $(boost_filetypes_$(1)),a so ln cmake)

# Function that updates debhelper files for a given library
# Input: component, library, suffix
# Output: none
mk_files = $(foreach fn,$(call boost_filetypes,$(2)),$(call mk_$(fn)_files,$(1),$(2),$(3)))

# helpers to make and install lintian override files

# Input: package, override
add_override = echo $(1): $(2) >> debian/$(1).lintian-overrides;

# Input: override
add_dev_override = $(call add_override,libboost$(PKGVERSION)-dev,$(1))
add_doc_override = $(call add_override,libboost$(PKGVERSION)-doc,$(1))

# Input: component, lintian-warning
add_lib_override = $(call add_override,$(call mk_pkg_lib,$(1)),$(2))
add_libdev_override = $(call add_override,$(call mk_pkg_dev,$(1)),$(2))

# Input: package-name-base, versioned-package-name
cp_debhelper = set -e ; for s in doc-base examples postinst prerm README.Debian; do \
	if test -f debian/$(1).$$s; then cp -f debian/$(1).$$s debian/$(2).$$s; fi; done

# Function that updates debhelper files for all libraries shipped.
mk_debhelper_files = \
	$(call add_dev_override,extra-license-file) \
	$(call add_doc_override,extra-license-file) \
	$(foreach l, $(boost_libs), \
		echo "making debhelper files for $(l)..."; \
		$(call add_lib_override,$(l),package-name-doesnt-match-sonames) \
		$(foreach ll, $(call boost_lib,$(l)), \
			$(foreach suf, $(call boost_suffixes,$(l)), \
				$(call mk_files,$(l),$(ll),$(suf)) \
			) \
		) \
	)

TOOLSET_CONFIG = 'using gcc : : : <compileflags>"$(CPPFLAGS)" <cflags>"$(CFLAGS)" <cxxflags>"$(CXXFLAGS) -Wno-unused-local-typedefs" <linkflags>"$(LDFLAGS)" ;'
BUILD_CONTEXT = yes
BUILD_LONG_DOUBLE = yes
BUILD_NUMPY = yes

# Disable long double on some architectures
ifneq (,$(filter $(DEB_HOST_ARCH), alpha arm armel armhf arm64 ppc64el hppa mips mipsel sh4 powerpc ppc64))
BUILD_LONG_DOUBLE = no
endif

# Disable context, coroutine, fiber on some architectures
ifneq (,$(filter $(DEB_HOST_ARCH), alpha hppa ia64 m68k mips64 powerpcspe s390 sh4 sparc sparc64 x32))
BUILD_CONTEXT = no
endif

ifeq ($(DEB_BUILD_ARCH), arm64)
JAM_OPT += pch=off
endif

# we dsable stacktrace from exceptions on some platforms due to possible memory leaks. See #1102107
ifneq (,$(filter $(DEB_HOST_ARCH), i386 alpha hppa hurd-i386 m68k sh4))
JAM_OPT += boost.stacktrace.from_exception=off
endif

# if we're building with context, coroutine, fiber, add the libraries to the list
ifeq ($(BUILD_CONTEXT), yes)
boost_libs += context coroutine fiber
else
JAM_WITHOUT += --without-context --without-coroutine --without-fiber
endif

# if we're building with long double, add the libraries to the list
ifeq ($(BUILD_LONG_DOUBLE), yes)
boost_lib_math += $(boost_lib_math_long_double)
else
JAM_OPT += --disable-long-double
endif

# if we're building with numpy, add the libraries to the list
ifeq ($(BUILD_NUMPY), yes)
boost_libs += numpy
endif

exampledir = debian/libboost$(PKGVERSION)-doc/usr/share/doc/libboost$(PKGVERSION)-doc/examples
b2 = $(CURDIR)/b2
bbv2dir = $(CURDIR)/tools/build

# With --ignore-site-config, can probably drop Build-Conflicts on boost-build.
JAM = $(b2) $(JOBS) -q -d2 $(JAM_OPT) --layout=system --ignore-site-config --user-config=$(CURDIR)/user-config.jam debug-symbols=on
JAM_DOC = $(b2) $(JOBS) -q -d2 --ignore-site-config --user-config=$(CURDIR)/user-config-doc.jam

%:
	dh $@ --with python3

override_dh_auto_configure: user-config.jam make-debhelper
ifeq ($(DEB_BUILD_ARCH), x32)
	cp tools/build/src/tools/gcc.jam tools/build/src/tools/gcc.jam.bak
	sed -i -e 's|^.*compile-link-flags.*-m32.*|#\0|g' \
	       -e 's|^.*toolset.flags.*-march=i686.*|#\0|g' \
		tools/build/src/tools/gcc.jam
endif

override_dh_auto_build-common: $(b2) b2.1 bjam.1
	$(JAM) $(JAM_WITHOUT) --without-python
	set -e ; for pyver in $(pyversions); do \
		echo "Building Boost.Python for python version $$pyver"; \

=== debian/tests/control ===
Tests: atomic
Depends: libboost-atomic1.90-dev, build-essential, cmake

Tests: chrono
Depends: libboost-chrono1.90-dev, build-essential, cmake

Tests: context
Depends: libboost-context1.90-dev, build-essential, cmake

Tests: container
Depends: libboost-container1.90-dev, build-essential, cmake

Tests: coroutine
Depends: libboost-coroutine1.90-dev, build-essential, cmake

Tests: datetime
Depends: libboost-date-time1.90-dev, build-essential, cmake

Tests: exception
Depends: libboost-exception1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: fiber
Depends: libboost-fiber1.90-dev, build-essential, cmake

Tests: filesystem
Depends: libboost-filesystem1.90-dev, build-essential, cmake

#Tests: graph
#Depends: libboost-graph1.90-dev, build-essential, cmake
#Restrictions: allow-stderr

#Tests: graph-parallel
#Depends: libboost-graph-parallel1.90-dev, libboost-mpi1.90-dev, mpi-default-dev, build-essential, libgraph-easy-perl, cmake
#Architecture: !armhf
#Restrictions: allow-stderr

Tests: iostreams
Depends: libboost-iostreams1.90-dev, build-essential, cmake

Tests: locale
Depends: libboost-locale1.90-dev, build-essential, cmake

Tests: log
Depends: libboost-log1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: math
Depends: libboost-math1.90-dev, build-essential, cmake

Tests: mpi
Depends: libboost-mpi1.90-dev, mpi-default-dev, build-essential, cmake
Architecture: !armhf !i386
Restrictions: allow-stderr

#Tests: mpi-python
#Depends: libboost-mpi-python1.90-dev, mpi-default-dev, python3-minimal
#Architecture: !armhf
#Restrictions: allow-stderr

Tests: program-options
Depends: libboost-program-options1.90-dev, build-essential, cmake

Tests: python
Depends: libboost-python1.90-dev, python3-minimal, cmake, build-essential, clang
Restrictions: allow-stderr

Tests: random
Depends: libboost-random1.90-dev, build-essential, cmake

Tests: regex
Depends: libboost-regex1.90-dev, build-essential, cmake, html2text

Tests: serialization
Depends: libboost-serialization1.90-dev, libboost-random1.90-dev, build-essential, cmake

Tests: stacktrace
Depends: libboost-stacktrace1.90-dev, build-essential, cmake

#Tests: system
#Depends: build-essential, cmake
#Restrictions: allow-stderr

Tests: test
Depends: libboost-test1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: thread
Depends: libboost-thread1.90-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: timer
Depends: libboost-timer1.90-dev, build-essential, cmake

Tests: type-erasure
Depends: libboost-type-erasure1.90-dev, build-essential, cmake

Tests: wave
Depends: libboost-wave1.90-dev, libboost-thread1.90-dev, build-essential, cmake
